unit RxViewX;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls, RXVIEWXLib_TLB, Menus, about, ComCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    MnuFile: TMenuItem;
    Open1: TMenuItem;
    MnuOptions: TMenuItem;
    Rasterscaling1: TMenuItem;
    Normal1: TMenuItem;
    ScaletoGrey1: TMenuItem;
    PreserveBlack1: TMenuItem;
    Exit1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Zoom: TMenuItem;
    ZoomAll: TMenuItem;
    Pan: TMenuItem;
    ViewXContext: TMenuItem;
    Window1: TMenuItem;
    Close1: TMenuItem;
    N1: TMenuItem;
    MnuWindow: TMenuItem;
    mnuClose: TMenuItem;
    mnuCloseAll: TMenuItem;
    Help1: TMenuItem;
    Info1: TMenuItem;
    SaveAs1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    View1: TMenuItem;
    mnuStatus: TMenuItem;
    mnuControltb: TMenuItem;
    mnuRedlinetb: TMenuItem;
    mnuTabs: TMenuItem;
    mnuLayoutontabs: TMenuItem;
    mnuBird: TMenuItem;
    mnuLayouts: TMenuItem;
    mnuPage: TMenuItem;
    Zoom1: TMenuItem;
    ZoomWindow1: TMenuItem;
    Zoom111: TMenuItem;
    ZoomExtent1: TMenuItem;
    ZoomWidth1: TMenuItem;
    ZoomHeight1: TMenuItem;
    ZoomIn1: TMenuItem;
    ZoomOut1: TMenuItem;
    N3: TMenuItem;
    Pan1: TMenuItem;
    MnuMarkup: TMenuItem;
    Preferences1: TMenuItem;
    Control1: TMenuItem;
    Filefilterdialog1: TMenuItem;
    Preferencesdialog1: TMenuItem;
    Vectorcontroldialog1: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    Measure1: TMenuItem;
    AboutRxViewXDelphiSample1: TMenuItem;
    MnuSave2Vector: TMenuItem;
    MnuSave2Raster: TMenuItem;
    N11: TMenuItem;
    MnuShowDialogHelp: TMenuItem;
    MnuBackGroundColor: TMenuItem;
    MnuBlack: TMenuItem;
    MnuWhite: TMenuItem;
    MnuGrey: TMenuItem;
    MnuChooseColor: TMenuItem;
    ColorDialog1: TColorDialog;
    StatusBar1: TStatusBar;
    MnuOverlay: TMenuItem;
    RxViewX1: TRxViewX;
    procedure Open1Click(Sender: TObject);
    procedure Normal1Click(Sender: TObject);
    procedure ScaletoGrey1Click(Sender: TObject);
    procedure PreserveBlack1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure ZoomAllClick(Sender: TObject);
    procedure mnuCloseClick(Sender: TObject);
    procedure mnuCloseAllClick(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure OnMnuLayoutListClick(Sender: TObject);
    procedure OnMnuPageListClick(Sender: TObject);
    procedure OnRecentListClick(Sender: TObject);
    procedure OnMnuWindowsListClick(Sender: TObject);
    procedure mnuStatusClick(Sender: TObject);
    procedure mnuControltbClick(Sender: TObject);
    procedure mnuRedlinetbClick(Sender: TObject);
    procedure mnuTabsClick(Sender: TObject);
    procedure mnuLayoutontabsClick(Sender: TObject);
    procedure mnuBirdClick(Sender: TObject);
    procedure RxViewX1ViewComplete(Sender: TObject; nStatus: Smallint);
    procedure ZoomWindow1Click(Sender: TObject);
    procedure Zoom111Click(Sender: TObject);
    procedure ZoomExtent1Click(Sender: TObject);
    procedure ZoomWidth1Click(Sender: TObject);
    procedure ZoomHeight1Click(Sender: TObject);
    procedure ZoomIn1Click(Sender: TObject);
    procedure ZoomOut1Click(Sender: TObject);
    procedure Pan1Click(Sender: TObject);
    procedure Preferences1Click(Sender: TObject);
    procedure Control1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Export1Click(Sender: TObject);
    procedure Refresh1Click(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure RubberPen1Click(Sender: TObject);
    procedure RubberBand1Click(Sender: TObject);
    procedure Push1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure Link1Click(Sender: TObject);
    procedure Text1Click(Sender: TObject);
    procedure FreehandPen1Click(Sender: TObject);
    procedure Lines2Click(Sender: TObject);
    procedure Curves1Click(Sender: TObject);
    procedure MeasurementArea2Click(Sender: TObject);
    procedure Rectangle1Click(Sender: TObject);
    procedure RoundedRectangle1Click(Sender: TObject);
    procedure Oval1Click(Sender: TObject);
    procedure Bubble1Click(Sender: TObject);
    procedure Arrow1Click(Sender: TObject);
    procedure Dimension1Click(Sender: TObject);
    procedure Filefilterdialog1Click(Sender: TObject);
    procedure Preferencesdialog1Click(Sender: TObject);
    procedure Vectorcontroldialog1Click(Sender: TObject);
    procedure Measure1Click(Sender: TObject);
    procedure AboutRxViewXDelphiSample1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
    procedure MnuSave2VectorClick(Sender: TObject);
    procedure MnuSave2RasterClick(Sender: TObject);
    procedure MnuShowDialogHelpClick(Sender: TObject);
    procedure MnuWhiteClick(Sender: TObject);
    procedure MnuBlackClick(Sender: TObject);
    procedure MnuGreyClick(Sender: TObject);
    procedure MnuChooseColorClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure RxViewX1Progress(Sender: TObject; nPercent: Smallint;
      var bAbort: Integer);
    procedure RxViewX1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure RxViewX1FileOpenEvent(Sender: TObject; var psFileName: WideString;
      var bOK: Integer);
    procedure RxViewX1FileCloseEvent(Sender: TObject;
      const sFileName: WideString; var bOK: Integer);
    procedure MnuOverlayClick(Sender: TObject);
  private
    { Private declarations }
  public
    //procedure OnRecentListClick(Sender: TMenuItem); override;
    procedure TurnMenusOn();
    procedure TurnMenusOff();
    { Public declarations }
  end;

var
  Form1: TForm1;
  RxFile : Widestring;
  WindowItem : Integer;
  CurrentFile : WideString;
  OpenFiles : Array [1..10] of widestring;

implementation

{$R *.DFM}
uses shellAPI, Progress;


procedure TForm1.Open1Click(Sender: TObject);
var
NewItem : TMenuItem;
MenuCounter, Counter, I : Integer;
sCaption : WideString;
begin
    //Load a document into RxViewX
    try
    Form1.Cursor := crHourGlass;
    RxViewX1.Cursor := crHourGlass;
    RxViewX1.FileOpenDialog;
    MenuCounter := mnuFile.Count - 1;
    for I := MenuCounter downto 8 do
    begin
        mnuFile.Remove(mnuFile.Items[I]);
    end;
    NewItem := TMenuItem.Create(Self);
    NewItem.Caption := '-';
    { add the new item to the recent files list }
    mnuFile.Add(NewItem);
    { now create and add a menu item for each form }
    for  Counter := 1 to RxViewX1.NumRecentFiles do
    begin
        NewItem := TMenuItem.Create(Self);
        RxViewX1.GetRecentFileName( Counter - 1, sCaption);
        NewItem.Caption := sCaption;
        NewItem.OnClick := OnRecentListClick;
        mnuFile.Add(NewItem);
    end;

    except
         Application.MessageBox('An error occured','Error',MB_OK);
    end;

end;

procedure TForm1.Normal1Click(Sender: TObject);
begin
Normal1.Checked := True;
RxViewX1.RasterScaleType := 0;
RxViewX1.Refresh;
end;

procedure TForm1.ScaletoGrey1Click(Sender: TObject);
begin
ScaletoGrey1.Checked := True;
RxViewX1.RasterScaleType := 1;
RxViewX1.Refresh;
end;

procedure TForm1.PreserveBlack1Click(Sender: TObject);
begin
PreserveBlack1.Checked := True;
RxViewX1.RasterScaleType := 2;
RxViewX1.Refresh;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.ZoomAllClick(Sender: TObject);
begin
RxViewX1.Zoom(1);
end;


procedure TForm1.mnuCloseClick(Sender: TObject);
var
MenuCounter, I : Integer;
sFileName : WideString;
begin
         //Close current file
    RxViewX1.GetLoadedFileName(0, sFileName);
    If Trim(sFileName) <> '' Then RxViewX1.CloseFile( 0, '');
    RxViewX1.Update;

    if RxViewX1.NumloadedFiles < 1 then
    begin
        mnuClose.Visible := False;
        mnuCloseAll.Visible := False;
        TurnMenusOff;
        MenuCounter := MnuWindow.Count - 1;
        for I := MenuCounter downto 3 do
        begin
                MnuWindow.Remove(MnuWindow.Items[I]);
        end;

    end;

end;


procedure TForm1.mnuCloseAllClick(Sender: TObject);
var
MenuCounter, I : Integer;
begin
    //CLOSE ALL FILES
    RxViewX1.CloseFile (1, '');
    if RxViewX1.NumloadedFiles < 1 then
    begin
        mnuClose.Visible := False;
        mnuCloseAll.Visible := False;
        MenuCounter := MnuWindow.Count - 1;
        TurnMenusOff;
        for I := MenuCounter downto 3 do
        begin
                MnuWindow.Remove(MnuWindow.Items[I]);
        end;

    end;
end;



procedure TForm1.Info1Click(Sender: TObject);
var
plFileType : TOLEEnum;
pszFilterName : WideString;
pdFileSize : Double;

begin
    //Displays Built-in File Information dialog
    RxViewX1.FileInfoDialog;
    RxViewX1.GetFileInfo(plFileType, pszFilterName, pdFileSize);


end;


procedure TForm1.Print1Click(Sender: TObject);
var
v : Integer;
begin

{RxViewX has its own Printer dialog with more features than
a conventional Print Dialog.
Check documentation for different print directives}

    v := RxViewX1.PrintDocument();

end;

procedure TForm1.OnRecentListClick(Sender: TObject);
var
MnuSender : TMenuItem;
NewItem : TMenuItem;
SenderClassname : String;
MenuIndexnumber : String;
sCaption : WideString;
I, Counter : Integer;
MenuCounter : Integer;

begin
    Form1.Cursor := crHourglass;
    SenderClassname := Sender.ClassName;
    //Load a recently loaded file into RxViewX
    //RxViewX takes care of registry entry of recent files
    //Application.MessageBox(PChar(SenderClassname),'message', MB_OK);
    if Sender.ClassName = 'TMenuItem' then
    begin
            MnuSender := TMenuItem(Sender);
            MenuIndexnumber := inttoStr(MnuSender.MenuIndex);
            RxViewX1.GetRecentFileName( MnuSender.MenuIndex - 10, sCaption);
            RxViewX1.FileOpen(sCaption, sCaption);
            MenuCounter := mnuFile.Count - 1;
            for I := MenuCounter downto 9 do
            begin
             mnuFile.Remove(mnuFile.Items[I]);
            end;
            NewItem := TMenuItem.Create(Self);
            NewItem.Caption := '-';
                { add the new item to the recent files list }
            mnuFile.Add(NewItem);
                { now create and add a menu item for each form }
            for  Counter := 1 to RxViewX1.NumRecentFiles do
            begin
                NewItem := TMenuItem.Create(Self);
                RxViewX1.GetRecentFileName( Counter - 1, sCaption);
                NewItem.Caption := sCaption;
                NewItem.OnClick := OnRecentListClick;
                mnuFile.Add(NewItem);
            end;
    end;

end;


procedure TForm1.mnuStatusClick(Sender: TObject);
begin
//Toggle status bar visibility
    If mnuStatus.Checked Then
    begin
        mnuStatus.Checked := False;
        RxViewX1.ShowStatusbar := 0;
    end
    Else
    begin
        mnuStatus.Checked := True;
        RxViewX1.ShowStatusbar := 1;
    End;

end;

procedure TForm1.mnuControltbClick(Sender: TObject);
begin
    //Toggle Control toolbar visibility
    If mnuControltb.Checked Then
    begin
        mnuControltb.Checked := False;
        RxViewX1.ShowControlToolbar := 0;
    end
    Else
    begin
        mnuControltb.Checked := True;
        RxViewX1.ShowControlToolbar := 1;
    End;

end;

procedure TForm1.mnuRedlinetbClick(Sender: TObject);
begin
//Toggle redline toolbar visibility
    If mnuRedlinetb.Checked Then
    begin
        mnuRedlinetb.Checked := False;
        RxViewX1.ShowRedlineToolbar := 0;
    end
    Else
    begin
        mnuRedlinetb.Checked := True;
        RxViewX1.ShowRedlineToolbar := 1;
    End;

end;

procedure TForm1.mnuTabsClick(Sender: TObject);
begin
//Toggle filetabs visibility
    If mnuTabs.Checked Then
    begin
        mnuTabs.Checked := False;
        RxViewX1.ShowFileTabs := 0;
    end
    Else
    begin
        mnuTabs.Checked := True;
        RxViewX1.ShowFileTabs := 1;
    End;

end;

procedure TForm1.mnuLayoutontabsClick(Sender: TObject);
begin
//Toggle layouts on tabs on/off
    If mnuLayoutontabs.Checked Then
    begin
        RxViewX1.LayoutOnTabs := 0;
        mnuLayoutontabs.Checked := False;
    end
    Else
    begin
        RxViewX1.LayoutOnTabs := 1;
        mnuLayoutontabs.Checked := True;
    End;


end;

procedure TForm1.mnuBirdClick(Sender: TObject);
begin
 try
    //TOGGLE BIRD's EYE VIEW
    If mnuBird.Checked Then
    begin
        mnuBird.Checked := False;
        RxViewX1.ShowBirdsEyeView := 0;
    end
    Else
    begin
        mnuBird.Checked := True;
        RxViewX1.ShowBirdsEyeView := 1;
    End;
  except
      Application.MessageBox('An error occured while attempting to display birdseye view','Error',MB_OK); 
  end;
end;

procedure TForm1.OnMnuLayoutListClick(Sender: TObject);
var
MnuSender : TMenuItem;
SenderClassname : String;

begin
    RxViewx1.Cursor := crHourglass;
    Form2.Visible := True;
    SenderClassname := Sender.ClassName;
      //Loads layout selected by the user
    if Sender.ClassName = 'TMenuItem' then
    begin
            MnuSender := TMenuItem(Sender);
            RxViewX1.SelectLayout(MnuSender.MenuIndex);
    end;

end;


procedure TForm1.RxViewX1ViewComplete(Sender: TObject; nStatus: Smallint);
var
lNumLay : Longint;
lSelLay : Longint;
lNumPag : Longint;
lSelPag : Longint;
sLayoutName, sPageName : WideString;
I, MenuCounter, NumLoadedFiles : Integer;
NewItem : TMenuItem;
sFileName : WideString;
plFileType : TOLEenum;
pszFilterName : WideString;
pdFileSize : Double;


begin
    //THE VIEW COMPLETE EVENT is fired when RxViewX has finished loading a document
    lNumLay := 0;
    lSelLay := 0;
    lNumPag := 0;
    lSelPag := 0;

try
    if RxViewX1.NumloadedFiles > 1 then
    begin
        mnuOverlay.Enabled := True;
    end;
    if RxViewX1.NumloadedFiles < 2 then
    begin
        mnuOverlay.Enabled := False;
    end;


    if RxViewX1.NumLoadedFiles > 0 then
    begin
        TurnMenusOn;
    end
    else
    begin
        TurnMenusOff;
    end;
    Form2.Visible := False;
    //Refresh Open window list
    MenuCounter := MnuWindow.Count - 1;
    for I := MenuCounter downto 3 do
    begin
        MnuWindow.Remove(MnuWindow.Items[I]);
    end;
    NumLoadedFiles := RxViewX1.NumLoadedFiles;
    if (MnuWindow.Count < 3) then
    begin
        { first create the separator }
        NewItem := TMenuItem.Create(Self);
        NewItem.Caption := '-';
        { add the new item to the File menu }
        MnuWindow.Add(NewItem);

    end;
        { now create and add a menu item for all open files }
    For i := 1 To NumLoadedFiles do
    begin

         RxViewX1.GetLoadedFileName(i - 1, sFileName);
         NewItem := TMenuItem.Create(Self);
         NewItem.Caption := sFileName;
         NewItem.OnClick := OnMnuWindowsListClick;
         MnuWindow.Add(NewItem);
    end;

    //Refresh Layout list
    MenuCounter := mnuLayouts.Count - 1;
    if MenuCounter > 0 then
    begin
    for I := MenuCounter downto 0 do
    begin
        mnuLayouts.Remove(mnuLayouts.Items[I]);
    end;
    end;
    RxViewX1.GetLayoutInfo( lNumLay, lSelLay, lNumPag, lSelPag);
    For I := 1 To lNumLay do
    if lNumLay > 1 then
    begin
     begin
        RxViewX1.GetLayoutName( i - 1, sLayoutName);
        NewItem := TMenuItem.Create(Self);
        NewItem.Caption := sLayoutName;
        NewItem.OnClick := OnMnuLayoutListClick;
        mnuLayouts.Add(NewItem);
     end;
    end;

    //Refresh number of pages list
    MenuCounter := mnuPage.Count - 1;
    for I := MenuCounter downto 0 do
    begin
        mnuPage.Remove(mnuPage.Items[I]);
    end;
    if lNumPag > 1 then
    begin
        For I := 1 To lNumPag do
        begin
                RxViewX1.GetPageName( i - 1, sPageName);
                NewItem := TMenuItem.Create(Self);
                NewItem.Caption := sPageName;
                NewItem.OnClick := OnMnuPageListClick;
                mnuPage.Add(NewItem);
        end;
    end;
    Form1.Cursor := crDefault;
   except

   end;
    mnuCloseAll.Visible := True;
    mnuClose.Visible := True;
    RxViewX1.GetFileInfo(plFileType,pszFilterName,pdFileSize);
    if plFileType <> 3 then
    begin
     MnuSave2Vector.Enabled := False;
    end
    else
    begin
     MnuSave2Vector.Enabled := True;
    end;
    //This property holds the number of files currently loaded in RxViewX.

    Form2.Visible := False;

end;

procedure TForm1.OnMnuWindowsListClick(Sender: TObject);
var
MnuSender : TMenuItem;
MnuIndex : Integer;
SenderClassname : String;
sFileName : WideString;

begin
    Form1.Cursor := crHourglass;
    SenderClassname := Sender.ClassName;
      //Loads layout selected by the user
    if Sender.ClassName = 'TMenuItem' then
    begin
            MnuSender := TMenuItem(Sender);
            MnuIndex := MnuWindow.IndexOf(MnuSender) - 3;
            RxViewX1.GetLoadedFileName(MnuIndex, sFileName);
            RxViewX1.ActivateFile(sFileName);

    end;

end;

procedure TForm1.OnMnuPageListClick(Sender: TObject);
var
MnuSender : TMenuItem;
SenderClassname : String;

begin
    Form1.Cursor := crHourglass;
    SenderClassname := Sender.ClassName;
      //Loads layout selected by the user
    if Sender.ClassName = 'TMenuItem' then
    begin
            MnuSender := TMenuItem(Sender);
            RxViewX1.SelectPage(MnuSender.MenuIndex);
    end;

end;

procedure TForm1.ZoomWindow1Click(Sender: TObject);
var
bZoomWindow : Integer;
begin
bZoomWindow := RxViewX1.SetMouseActionType(1, 0, 0);
end;

procedure TForm1.Zoom111Click(Sender: TObject);
begin
RxViewX1.Zoom(None);
end;

procedure TForm1.ZoomExtent1Click(Sender: TObject);
begin
RxViewX1.Zoom(Extent);
end;

procedure TForm1.ZoomWidth1Click(Sender: TObject);
begin
RxViewX1.Zoom(2); //Width
end;

procedure TForm1.ZoomHeight1Click(Sender: TObject);
begin
RxViewX1.Zoom(3); //Height
end;



procedure TForm1.ZoomIn1Click(Sender: TObject);
begin
RxViewX1.Zoom(Inn);
end;

procedure TForm1.ZoomOut1Click(Sender: TObject);
begin
 RxViewX1.Zoom(Out);
end;

procedure TForm1.Pan1Click(Sender: TObject);
begin
//Check the Documentation for available mouse action types, subtypes and alternative types.
    RxViewX1.SetMouseActionType( 2, 0, 0);

end;

procedure TForm1.Preferences1Click(Sender: TObject);
begin
RxViewX1.RedlinePreferenceDialog;
end;

procedure TForm1.Control1Click(Sender: TObject);
begin
    //RxViewX takes care of RedlinecontrolDialog with just this one statement!
    RxViewX1.RedlineControlDialog;

end;

procedure TForm1.Save1Click(Sender: TObject);
begin
//You can use this dialog to save as a different type
    RxViewX1.SaveToRasterDialog;

end;

procedure TForm1.Export1Click(Sender: TObject);
begin
//You can use this dialog to save as a different type
    RxViewX1.SaveToVectorDialog;
end;

procedure TForm1.Refresh1Click(Sender: TObject);
begin
//UNIMPLEMENTED FEATURE
end;

procedure TForm1.Undo1Click(Sender: TObject);
begin
    try
    //RxViewX1.undo; //UNDO METHOD NOT IMPLEMENTED YET
    except

    end;

end;

procedure TForm1.RubberPen1Click(Sender: TObject);
begin
    RxViewX1.SetMouseActionType(7, 0, 0); //CHECK DOCUMENTATION FOR Main type, Sub type and Alternative type of mouse action.
end;

procedure TForm1.RubberBand1Click(Sender: TObject);
begin
    RxViewX1.SetMouseActionType(7, 1, 0);//CHECK DOCUMENTATION FOR Main type, Sub type and Alternative type of mouse action.
end;

procedure TForm1.Push1Click(Sender: TObject);
begin
//Check the Documentation for available mouse action types, subtypes and alternative types.
    RxViewX1.SetMouseActionType(6, 0, 0);

end;

procedure TForm1.Edit1Click(Sender: TObject);
begin
//Check the Documentation for available mouse action types, subtypes and alternative types.
    RxViewX1.SetMouseActionType(5, 0, 0);

end;

procedure TForm1.Link1Click(Sender: TObject);
begin
//Check the Documentation for available mouse action types, subtypes and alternative types.
    RxViewX1.SetMouseActionType(6, 0, 0);

end;

procedure TForm1.Text1Click(Sender: TObject);
begin
//CHECK DOCUMENTATION FOR Main type, Sub type and Alternative type of mouse action.
    RxViewX1.SetMouseActionType (9, 0, 0);

end;

procedure TForm1.FreehandPen1Click(Sender: TObject);
begin
//'Check the Documentation for available mouse action types, subtypes and alternative types.
    RxViewX1.SetMouseActionType (10, 0, 0);

end;

procedure TForm1.Lines2Click(Sender: TObject);
begin
//Check the Documentation for available mouse action types, subtypes and alternative types.
    RxViewX1.SetMouseActionType(10, 1, 0);

end;

procedure TForm1.Curves1Click(Sender: TObject);
begin
//Check the Documentation for available mouse action types, subtypes and alternative types.
    RxViewX1.SetMouseActionType (10, 2, 0);

end;

procedure TForm1.MeasurementArea2Click(Sender: TObject);
begin
//Check the Documentation for available mouse action types, subtypes and alternative types.
    RxViewX1.SetMouseActionType (10, 3, 0);

end;



procedure TForm1.Rectangle1Click(Sender: TObject);
begin
//Check the Documentation for available mouse action types, subtypes and alternative types.
    RxViewX1.SetMouseActionType (12, 0, 0);

end;

procedure TForm1.RoundedRectangle1Click(Sender: TObject);
begin
//CHECK DOCUMENTATION FOR Main type, Sub type and Alternative type of mouse action.
    RxViewX1.SetMouseActionType (12, 1, 0);

end;

procedure TForm1.Oval1Click(Sender: TObject);
begin
//Check the Documentation for available mouse action types, subtypes and alternative types.
    RxViewX1.SetMouseActionType (12, 2, 0);

end;

procedure TForm1.Bubble1Click(Sender: TObject);
begin
//Check the Documentation for available mouse action types, subtypes and alternative types.
    RxViewX1.SetMouseActionType (12, 3, 0);

end;

procedure TForm1.Arrow1Click(Sender: TObject);
begin
    RxViewX1.SetMouseActionType (11, 0, 0);
    //Check the Documentation for available mouse action types, subtypes and alternative types.
    //In this case mouse action to draw an arrow is 11.

end;

procedure TForm1.Dimension1Click(Sender: TObject);
begin
//Check the Documentation for available mouse action types, subtypes and alternative types.
    RxViewX1.SetMouseActionType (11, 1, 0);

end;

procedure TForm1.Filefilterdialog1Click(Sender: TObject);
begin
//Displays Built-in Filter Information dialog
    RxViewX1.FilterInfoDialog;

end;

procedure TForm1.Preferencesdialog1Click(Sender: TObject);
begin
//Displays Builtin Preference dialog
    RxViewX1.PreferenceDialog;

end;

procedure TForm1.Vectorcontroldialog1Click(Sender: TObject);
begin
//Displays Builtin Vector Control dialog
    RxViewX1.FileVectorControlDialog;
end;

procedure TForm1.Measure1Click(Sender: TObject);
begin
//Check the Documentation for available mouse action types, subtypes and alternative types.
   If not Measure1.Checked then
    begin
           RxViewX1.SetMouseActionType (4, 0, 0);
           Measure1.Checked := True;
    end
    else
    begin
        if Measure1.Checked then
        begin
         RxViewX1.SetMouseActionType (0, 0, 0);
         Measure1.Checked := False;
        end

    end;
end;

procedure TForm1.AboutRxViewXDelphiSample1Click(Sender: TObject);
begin
//   AboutBox.show;
   RxViewX1.AboutBox;

end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
Keystring : String;
pszPageName : WideString;
currentPage : Integer;
plNoOfLayouts : Integer;
plSelectedLayout : Integer;
plNoOfPages : Integer;
plSelectedPage : Integer;
begin

  Keystring := InttoStr(Key);
if Key = 34 then
begin
  RxViewX1.GetLayoutInfo(plNoOfLayouts,plSelectedLayout,plNoOfPages,plSelectedPage);
  try
         currentPage := plSelectedPage;
         if (currentPage < plNoOfPages + 1) or (plNoOfPages = -1) then RxViewX1.SelectPage(currentPage + 1);
  except

  end;

end;


if Key = 33 then
begin
    RxViewX1.GetLayoutInfo(plNoOfLayouts,plSelectedLayout,plNoOfPages,plSelectedPage);
  try
         currentPage := plSelectedPage;
         if (currentPage > 0) then RxViewX1.SelectPage(currentPage - 1);
  except

  end;
end;

end;

procedure TForm1.WMDropFiles(var Msg: TWMDropFiles);
var
  CFileName: array[0..MAX_PATH] of Char;
  WCFileName : WideString;
begin

 try
  if DragQueryFile(Msg.Drop, 0, CFileName, MAX_PATH) > 0 then
  begin
     WCFileName := String(CFileName);
     //RxViewX1.FileOpen(WCFileName,'');
     Msg.Result := 0;
  end;
 finally
    DragFinish(Msg.Drop);

 end;
end;

procedure TForm1.FormShow(Sender: TObject);
var
  NewItem: TMenuItem;
  I : Integer;
  sCaption : WideString;
  result : Integer;
begin
  { first create the separator }
  NewItem := TMenuItem.Create(Self);
  NewItem.Caption := '-';
  { add the new item to the File menu }
  mnuFile.Add(NewItem);
  { now create and add a menu item for each recent file }
  for  I := 1 to RxViewX1.NumRecentFiles do
  begin
    NewItem := TMenuItem.Create(Self);
    result := RxViewX1.GetRecentFileName( smallint(i - 1), sCaption);
    NewItem.Caption := sCaption;
    NewItem.OnClick := OnRecentListClick;
    mnuFile.Add(NewItem);
  end;
    StatusBar1.Panels[0].Width := Statusbar1.Width - 250;
    RxViewX1.ShowControlToolbar := 0;
    mnuControltb.Checked := False;
    RxViewX1.ShowFileTabs := 0;
    mnuTabs.Checked := False;
    RxViewX1.ShowRedlineToolbar := 0;
    mnuRedlinetb.Checked := False;
    RxViewX1.ShowStatusbar := 0;
    mnuStatus.Checked := False;
    mnuLayoutontabs.Checked := False;
    RxViewX1.LayoutOnTabs := 0;
    mnuBird.Checked := False;
    RxViewX1.ShowBirdsEyeView := 0;
    TurnMenusOff;

    //File tabs should be turned on in order to enable Layout tabs.
    //NOTE: Layout tabs cannot be toggled on the current loaded file,
    //but before loading of a file.

    mnuLayoutontabs.Checked := True;
    RxViewX1.LayoutOnTabs := 1;
    mnuTabs.Checked := True;
    RxViewX1.ShowFileTabs := 1;

ShellAPI.DragAcceptFiles (Handle, True);
end;

procedure TForm1.FormDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
if Source is TObject then
begin
    Accept := True;
end
else Accept := False;

end;

procedure TForm1.MnuSave2VectorClick(Sender: TObject);
begin
RxViewx1.SaveToVectorDialog;
end;

procedure TForm1.MnuSave2RasterClick(Sender: TObject);
begin
RxViewX1.SaveToRasterDialog;
end;

procedure TForm1.MnuShowDialogHelpClick(Sender: TObject);
begin
    If MnuShowDialogHelp.Checked Then
    begin
        MnuShowDialogHelp.Checked := False;
        RxViewX1.ShowHelpButtons := 0;
    end
    Else
    begin
        MnuShowDialogHelp.Checked := True;
        RxViewX1.ShowHelpButtons := 1;
    End;

end;

procedure TForm1.TurnMenusOn;
begin
    Close1.Enabled := True;
    Info1.Enabled := True;
    SaveAs1.Enabled := True;
    Print1.Enabled := True;
    mnuBird.Enabled := True;
    Zoom1.Enabled := True;
    Control1.Enabled := True;
    Vectorcontroldialog1.Enabled := True;
    Measure1.Enabled := True;
end;

procedure TForm1.TurnMenusOff;
begin
    Close1.Enabled := False;
    Info1.Enabled := False;
    SaveAs1.Enabled := False;
    Print1.Enabled := False;
    mnuBird.Enabled := False;
    Zoom1.Enabled := False;
    Control1.Enabled := False;
    Vectorcontroldialog1.Enabled := False;
    Measure1.Enabled := False;

end;

procedure TForm1.MnuWhiteClick(Sender: TObject);
begin
//mnuWhite.Checked := True;
//RxViewX1.BackColor := clWhite;
//RxViewX1.Refresh;

end;

procedure TForm1.MnuBlackClick(Sender: TObject);
begin
//mnuWhite.Checked := True;
//RxViewX1.BackColor := clBlack;
//RxViewX1.Refresh;

end;

procedure TForm1.MnuGreyClick(Sender: TObject);
begin
//mnuGrey.Checked := True;
//RxViewX1.BackColor := clGrey;
//RxViewX1.Refresh;

end;

procedure TForm1.MnuChooseColorClick(Sender: TObject);
begin
if ColorDialog1.Execute then
begin

//    RxViewX1.BackColor := ColorDialog1.Color;

end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
//
end;

procedure TForm1.RxViewX1Progress(Sender: TObject; nPercent: Smallint;
  var bAbort: Integer);
begin

Form2.ProgressBar1.Position := nPercent;
end;



procedure TForm1.RxViewX1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var

XWorldCoords : Longint;
YWorldCoords : Longint;
pdx : Double;
pdy : Double;
nPrecision : SmallInt;
sUnit : WideString;
begin

XWorldCoords := X;
YWorldCoords := Y;

RxViewX1.Screen2World(XWorldCoords,YWorldCoords);

pdx := XWorldCoords;
pdy := YWorldCoords;

RxViewX1.World2Original(pdx,pdy,nPrecision,sUnit);
StatusBar1.Panels[3].Text := sUnit;
StatusBar1.Panels[1].Text := 'X = ' + FloatToStrF(pdx, ffFixed, 10, nPrecision);
StatusBar1.Panels[2].Text := 'Y = ' + FloatToStrF(pdy, ffFixed, 10, nPrecision);


end;

procedure TForm1.RxViewX1FileOpenEvent(Sender: TObject;
  var psFileName: WideString; var bOK: Integer);
begin
    Form2.Visible := True;
    if RxViewX1.NumloadedFiles > 1 then
    begin
        mnuOverlay.Enabled := True;
    end;

end;

procedure TForm1.RxViewX1FileCloseEvent(Sender: TObject;
  const sFileName: WideString; var bOK: Integer);
var
MenuCounter, I : Integer;

begin
    if RxViewX1.NumloadedFiles < 1 then
    begin
        mnuClose.Visible := False;
        mnuCloseAll.Visible := False;
        TurnMenusOff;
        MenuCounter := MnuWindow.Count - 1;
        for I := MenuCounter downto 3 do
        begin
                MnuWindow.Remove(MnuWindow.Items[I]);
        end;

    end;
    if RxViewX1.NumloadedFiles < 2 then
    begin
        mnuOverlay.Enabled := False;
    end;


end;

procedure TForm1.MnuOverlayClick(Sender: TObject);
begin
        RxViewX1.OverlayDialog();
end;

end.
