unit About;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, rsFileVersion;

type
  TAboutBox = class(TForm)
    Panel1: TPanel;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    Comments: TLabel;
    OKButton: TButton;
    Image1: TImage;

    procedure OKButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AboutBox: TAboutBox;
  //FileVersion : TrsFileVersion;

implementation

{$R *.DFM}

procedure TAboutBox.OKButtonClick(Sender: TObject);
begin
AboutBox.Hide;
end;

procedure TAboutBox.FormActivate(Sender: TObject);
var
FV : TrsFileVersion;
begin
AboutBox.Caption := Application.Title;
ProductName.Caption := Application.Title;

FV := TrsFileVersion.Create;
 {get file version information}
if FV.GetFileVersion(ParamStr(0)) then
begin
        Version.Caption := 'Version : ' + FV.Version;
end;


end;

end.

