// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__6763005A_1774_4C6E_876D_758EB7314046__INCLUDED_)
#define AFX_MAINFRM_H__6763005A_1774_4C6E_876D_758EB7314046__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "RxViewX.h"

class CMainFrame : public CFrameWnd
{
	
public:
	CMainFrame();
	CRxViewX    m_wndView;
protected: 
	DECLARE_DYNAMIC(CMainFrame)

// Attributes
public:
	int	m_Action;

	long	m_lNoOfLayouts;
	long	m_lSelLayout;
	long	m_lNoOfPages;
	long	m_lSelPage;
	BSTR	m_bsName;
	
	void	SplitFileName(LPSTR PathName, LPSTR FileName);
	void	Double2Str(char * str, double ant, int pres);
	void	DoOnFile(int index);
	void	DoOnWindow(int index);

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;


// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSetFocus(CWnd *pOldWnd);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
	afx_msg void OnViewRxFileTabs();
	afx_msg void OnViewRxControlBar();
	afx_msg void OnViewRxRedlineBar();
	afx_msg void OnViewRxStatusBar();
	afx_msg void OnZoomAll();
	afx_msg void OnZoomHeight();
	afx_msg void OnZoomWidth();
	afx_msg void OnZoomNone();
	afx_msg void OnZoomIn();
	afx_msg void OnZoomOut();
	afx_msg void OnZoomWindow();
	afx_msg void OnPan();
	afx_msg void OnFileOpen();
	afx_msg void OnFileClose();
	afx_msg void OnWindowClose();
	afx_msg void OnWindowCloseAll();
	afx_msg void OnFile1();
	afx_msg void OnFile2();
	afx_msg void OnFile3();
	afx_msg void OnFile4();
	afx_msg void OnFile5();
	afx_msg void OnFile6();
	afx_msg void OnFile7();
	afx_msg void OnFile8();
	afx_msg void OnWindow1();
	afx_msg void OnWindow2();
	afx_msg void OnWindow3();
	afx_msg void OnWindow4();
	afx_msg void OnWindow5();
	afx_msg void OnWindow6();
	afx_msg void OnWindow7();
	afx_msg void OnWindow8();
	afx_msg void OnWindow9();
	afx_msg void OnViewRxLayOnTabs();
	afx_msg void OnViewBev();
	afx_msg void OnOptFilter();
	afx_msg void OnOptPref();
	afx_msg void OnOptVector();
	afx_msg void OnRedPref();
	afx_msg void OnRedControl();
	afx_msg void OnFilePrint();
	afx_msg void OnFileInfo();
	afx_msg void OnFileVxPrint();
	afx_msg void OnOptMeasure();
	afx_msg void OnLayout1();
	afx_msg void OnLayout2();
	afx_msg void OnLayout3();
	afx_msg void OnLayout4();
	afx_msg void OnLayout5();
	afx_msg void OnLayout6();
	afx_msg void OnLayout7();
	afx_msg void OnLayout8();
	afx_msg void OnLayout9();
	afx_msg void OnPage1();
	afx_msg void OnPage2();
	afx_msg void OnPage3();
	afx_msg void OnPage4();
	afx_msg void OnPage5();
	afx_msg void OnPage6();
	afx_msg void OnPage7();
	afx_msg void OnPage8();
	afx_msg void OnPage9();
	afx_msg void OnMouseDownRxviewxctrl(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpRxviewxctrl(short Button, short Shift, long x, long y);
	afx_msg void OnMouseMoveRxviewxctrl(short Button, short Shift, long x, long y);
	afx_msg void OnHelpWantedRxviewxctrl(short nDialogID);
	afx_msg void OnViewRxShowHelp();
	afx_msg void OnFileSaveRaster();
	afx_msg void OnFileSaveVector();
	afx_msg void OnStatusInformationRxviewxctrl(LPCTSTR sStatusText);
	afx_msg void OnFileOpenRxviewxctrl(BSTR FAR* psFileName, long FAR* bOK);
	afx_msg void OnDestroy();
	afx_msg void OnFileOverlay();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__6763005A_1774_4C6E_876D_758EB7314046__INCLUDED_)
